#include	"spi.h"
#include	"ascii27segment.h"
#include 	<p18cxxx.h>  
#include 	<delays.h>
#include	<string.h>

#define	WAIT_4_SEND		Nop();Nop();Nop();Nop();Nop();Nop();Nop();Nop();Nop()
#define	LATCH_DELAY		Nop()

#define	MBI_OUT_OFF		(PORTCbits.RC2=1)
#define	MBI_OUT_ON		(PORTCbits.RC2=0)

#define	MBI_WRITE(b)	SSPBUF=(b);WAIT_4_SEND
#define	MBI_LATCH		PORTCbits.RC1=1;LATCH_DELAY;PORTCbits.RC1=0

void	SPIInit(void)
{
	//	Enable Synchronous Serial Port plz

	SSPCON1bits.SSPEN	=	1;

	//	Data sampled at middle 

	SSPSTATbits.SMP		=	0;

	//	Data transmitted on rising edge of SCK

	SSPSTATbits.CKE		=	1;

	//	SSPBUF is writen while is still transmitting the previous word
	//	collision allowed

	SSPCON1bits.WCOL	=	1;

	//	Clock Polarity in IDLE state at low level

	SSPCON1bits.CKP		=	0;

	//	SPI Master mode, clock = Fosc/4 plz

	SSPCON1bits.SSPM3	=	0;
	SSPCON1bits.SSPM2	=	0;
	SSPCON1bits.SSPM1	=	0;
	SSPCON1bits.SSPM0	=	0;
}

void	SPIPutc(unsigned char by_Byte)
{
	//	Turn Off MBI OUTs

	MBI_OUT_OFF;

	//	Cifra	1
	MBI_WRITE(by_Byte);

	//	Cifra	2
	MBI_WRITE(by_Byte);

	//	Latch	MBI1
//	MBI_LATCH;

	//	Cifra	3
	MBI_WRITE(by_Byte);

	//	Cifra	4
	MBI_WRITE(by_Byte);

	//	Latch	MBI2
//	MBI_LATCH;

	//	Cifra	5
	MBI_WRITE(by_Byte);

	//	Cifra	6
	MBI_WRITE(by_Byte);

	//	Latch	MBI3
//	MBI_LATCH;

	//	Cifra	7
	MBI_WRITE(by_Byte);

	//	Cifra	8
	MBI_WRITE(by_Byte);

	//	Latch	MBI4
//	MBI_LATCH;

	//	Cifra	9
	MBI_WRITE(by_Byte);

	//	Cifra	10
	MBI_WRITE(by_Byte);

	//	Latch	MBI5
	MBI_LATCH;

	//	Turn ON MBI OUTs

	MBI_OUT_ON;
}

void	SPIASCIIPutc(unsigned char by_Byte)
{
	//	Turn Off MBI OUTs

	MBI_OUT_OFF;

	//	Cifra	1
	MBI_WRITE(AsciiTo7Segment(by_Byte));

	//	Cifra	2
	MBI_WRITE(AsciiTo7Segment(by_Byte));

	//	Latch	MBI1
//	MBI_LATCH;

	//	Cifra	3
	MBI_WRITE(AsciiTo7Segment(by_Byte));

	//	Cifra	4
	MBI_WRITE(AsciiTo7Segment(by_Byte));

	//	Latch	MBI2
//	MBI_LATCH;

	//	Cifra	5
	MBI_WRITE(AsciiTo7Segment(by_Byte));

	//	Cifra	6
	MBI_WRITE(AsciiTo7Segment(by_Byte));

	//	Latch	MBI3
//	MBI_LATCH;

	//	Cifra	7
	MBI_WRITE(AsciiTo7Segment(by_Byte));

	//	Cifra	8
	MBI_WRITE(AsciiTo7Segment(by_Byte));

	//	Latch	MBI4
//	MBI_LATCH;

	//	Cifra	9
	MBI_WRITE(AsciiTo7Segment(by_Byte));

	//	Cifra	10
	MBI_WRITE(AsciiTo7Segment(by_Byte));

	//	Latch	MBI5
	MBI_LATCH;

	//	Turn ON MBI OUTs

	MBI_OUT_ON;
}

void	SPIASCIIPuts(char* by_ByteBuffer)
{
	char	c_char;

	c_char	=	by_ByteBuffer[0];

	c_char	=	AsciiTo7Segment(by_ByteBuffer[0]);

	//	Turn Off MBI OUTs

	MBI_OUT_OFF;

	//	Cifra	10
	MBI_WRITE(AsciiTo7Segment(by_ByteBuffer[9]));

	//	Cifra	9
	MBI_WRITE(AsciiTo7Segment(by_ByteBuffer[8]));

	//	Latch	MBI5
//	MBI_LATCH;

	//	Cifra	8
	MBI_WRITE(AsciiTo7Segment(by_ByteBuffer[7]));

	//	Cifra	7
	MBI_WRITE(AsciiTo7Segment(by_ByteBuffer[6]));

	//	Latch	MBI4
//	MBI_LATCH;

	//	Cifra	6
	MBI_WRITE(AsciiTo7Segment(by_ByteBuffer[5]));

	//	Cifra	5
	MBI_WRITE(AsciiTo7Segment(by_ByteBuffer[4]));

	//	Latch	MBI3
//	MBI_LATCH;

	//	Cifra	4
	MBI_WRITE(AsciiTo7Segment(by_ByteBuffer[3]));
	//	Cifra	3
	MBI_WRITE(AsciiTo7Segment(by_ByteBuffer[2]));
	//	Latch	MBI2
//	MBI_LATCH;

	//	Cifra	2
	MBI_WRITE(AsciiTo7Segment(by_ByteBuffer[1]));

	//	Cifra	1
	MBI_WRITE(AsciiTo7Segment(by_ByteBuffer[0]));

	//	Latch	MBI1
	MBI_LATCH;

	//	Turn ON MBI OUTs

	MBI_OUT_ON;
}

void	SPIASCIIPutsROM(const	rom char* by_ByteBuffer)
{
	char	c_char;

	c_char	=	by_ByteBuffer[0];

	c_char	=	AsciiTo7Segment(by_ByteBuffer[0]);

	//	Turn Off MBI OUTs

	MBI_OUT_OFF;

	//	Cifra	10
	MBI_WRITE(AsciiTo7Segment(by_ByteBuffer[9]));

	//	Cifra	9
	MBI_WRITE(AsciiTo7Segment(by_ByteBuffer[8]));

	//	Latch	MBI5
//	MBI_LATCH;

	//	Cifra	8
	MBI_WRITE(AsciiTo7Segment(by_ByteBuffer[7]));

	//	Cifra	7
	MBI_WRITE(AsciiTo7Segment(by_ByteBuffer[6]));

	//	Latch	MBI4
//	MBI_LATCH;

	//	Cifra	6
	MBI_WRITE(AsciiTo7Segment(by_ByteBuffer[5]));

	//	Cifra	5
	MBI_WRITE(AsciiTo7Segment(by_ByteBuffer[4]));

	//	Latch	MBI3
//	MBI_LATCH;

	//	Cifra	4
	MBI_WRITE(AsciiTo7Segment(by_ByteBuffer[3]));
	//	Cifra	3
	MBI_WRITE(AsciiTo7Segment(by_ByteBuffer[2]));
	//	Latch	MBI2
//	MBI_LATCH;

	//	Cifra	2
	MBI_WRITE(AsciiTo7Segment(by_ByteBuffer[1]));

	//	Cifra	1
	MBI_WRITE(AsciiTo7Segment(by_ByteBuffer[0]));

	//	Latch	MBI1
	MBI_LATCH;

	//	Turn ON MBI OUTs

	MBI_OUT_ON;
}
